package cn.ecpark.service.usergw.biz.filters.bean;

import java.util.HashMap;
import java.util.Map.Entry;

import org.apache.dubbo.config.ReferenceConfig;
import org.apache.dubbo.config.utils.ReferenceConfigCache;
import org.apache.dubbo.rpc.service.GenericService;

/**
 * GenericServicePool
 */
public class GenericServicePool {

    private class ReferenceConfigStore {
        private ReferenceConfig<GenericService> ref;
        private GenericService gs;

        public ReferenceConfigStore(ReferenceConfig<GenericService> refValue) {
            this.ref = refValue;
            this.gs = ref.get();
        }

        public GenericService get() {
            return gs;
        }

        public void destroy() {
            this.ref.destroy();
            this.ref = null;
            this.gs = null ;
        }
    }

    HashMap<String, ReferenceConfigStore> gsDictionary;

    public GenericServicePool() {
        gsDictionary = new HashMap<String, ReferenceConfigStore>();
    }

    @Override
    protected void finalize() throws Throwable {
    
        for(Entry<String, ReferenceConfigStore> entry : gsDictionary.entrySet()) {
            entry.getValue(). destroy();
        }
        super.finalize();
    }

    public GenericService get(String key) {
        return gsDictionary.get(key).get();
    }

    public void put(String key, ReferenceConfig<GenericService> ref) {
        ReferenceConfigStore refStore = new ReferenceConfigStore(ref);
        gsDictionary.put(key, refStore);
    }
}