package cn.ecpark.service.usergw.config.bean;

import org.springframework.cloud.gateway.filter.ratelimit.KeyResolver;
import org.springframework.context.annotation.Bean;
import org.springframework.stereotype.Component;

import cn.ecpark.service.usergw.biz.filters.bean.GenericServicePool;
import cn.ecpark.service.usergw.biz.filters.factory.DubboGatewayFilterFactory;
import cn.ecpark.service.usergw.config.ConfigApollo;
import reactor.core.publisher.Mono;

@Component
public class ConfigBean {

    @Bean
    KeyResolver ipResolver() {
        return exchange -> Mono.just(exchange.getRequest().getRemoteAddress().getHostString());
    }

    @Bean
    public GenericServicePool genericServicePool() {
        return new GenericServicePool();
    }

    @Bean
    ConfigApollo configApollo() {      
        return new ConfigApollo();
    }

    @Bean
    public DubboGatewayFilterFactory dubboFilterFactory() {
        return new DubboGatewayFilterFactory();
    }
}