package cn.ecpark.service.usergw;

import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.boot.test.context.SpringBootTest.WebEnvironment;
import org.springframework.boot.web.server.LocalServerPort;
import org.springframework.core.annotation.Order;
import org.springframework.test.context.TestPropertySource;
import org.springframework.test.context.junit4.SpringRunner;

import reactor.netty.http.client.HttpClient;
import reactor.netty.http.client.HttpClient.ResponseReceiver;
import reactor.netty.http.client.HttpClientResponse;


@SpringBootTest(classes = App.class, webEnvironment = WebEnvironment.RANDOM_PORT)
@RunWith(SpringRunner.class)
@TestPropertySource(locations = "classpath:/resources/test2.properties", properties = {"apollo.meta=", "app.id="})
public class TestHttp2DubboConfig2 {

    @LocalServerPort
    private int serverPort;

    @Test
    public void Test2RequestHttp2DubboSetHeader() {

        // Test Base Url
        HttpClient client = HttpClient.create();
        ResponseReceiver<?> receiver;
        String content;

        receiver = client.baseUrl("http://localhost:" + serverPort + "/dubbo/hello")
                .headers(h -> h.set("method", "Hello")).get();

        HttpClientResponse response = receiver.response().block();
        Assert.assertNotNull(response); 
        Assert.assertEquals(response.status().code(), 404);
        content = receiver.responseContent().asString().blockLast();
        Assert.assertNotNull(content); 
        Assert.assertEquals(content, "Not Found");
    }

 
}