

package cn.ecpark.service.usergw;

import org.junit.Assert;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.boot.test.context.SpringBootTest.WebEnvironment;
import org.springframework.boot.web.server.LocalServerPort;
import org.springframework.core.annotation.Order;
import org.springframework.test.context.TestPropertySource;
import org.springframework.test.context.junit4.SpringRunner;

import reactor.netty.http.client.HttpClient;
import reactor.netty.http.client.HttpClient.ResponseReceiver;
import reactor.netty.http.client.HttpClientResponse;

// TODO: 添加附加Dubbo Service for Test启动进程
@SpringBootTest(classes = App.class, webEnvironment = WebEnvironment.RANDOM_PORT)
@RunWith(SpringRunner.class)
@TestPropertySource(locations = "classpath:/resources/test5.properties", properties = {"apollo.namespace=", "app.id=gateway"})
@Ignore
public class TestHttp2DubboConfig6 {

    @LocalServerPort
    private int serverPort;

    @Test
    
    public void Test1LoadDefaultApolloConfig() {
        // Test Base Url

        HttpClient client = HttpClient.create();
        ResponseReceiver<?> receiver;
        String content;

        receiver = client.baseUrl("http://localhost:" + serverPort + "/dubbo/hello1")
                .headers(h -> h.set("method", "Hello")).get();

        HttpClientResponse response = receiver.response().block();
        Assert.assertNotNull(response); 
        
        if(response.status().code() == 200) {
            content = receiver.responseContent().asString().blockLast();
            Assert.assertNotNull(content); 
            Assert.assertEquals("Hello Dubbo", content);
        } else {
            Assert.assertEquals(429, response.status().code());
        }
    }

  


 
}
 